use {events, libc};
use super::ffi;
use VirtualKeyCode;

pub fn keysym_to_element(keysym: libc::c_uint) -> Option<VirtualKeyCode> {
    Some(match keysym {
        ffi::XK_BackSpace => events::VirtualKeyCode::Back,
        ffi::XK_Tab => events::VirtualKeyCode::Tab,
        //ffi::XK_Linefeed => events::VirtualKeyCode::Linefeed,
        //ffi::XK_Clear => events::VirtualKeyCode::Clear,
        ffi::XK_Return => events::VirtualKeyCode::Return,
        //ffi::XK_Pause => events::VirtualKeyCode::Pause,
        //ffi::XK_Scroll_Lock => events::VirtualKeyCode::Scroll_lock,
        //ffi::XK_Sys_Req => events::VirtualKeyCode::Sys_req,
        ffi::XK_Escape => events::VirtualKeyCode::Escape,
        ffi::XK_Delete => events::VirtualKeyCode::Delete,
        ffi::XK_Multi_key => events::VirtualKeyCode::Compose,
        //ffi::XK_Kanji => events::VirtualKeyCode::Kanji,
        //ffi::XK_Muhenkan => events::VirtualKeyCode::Muhenkan,
        //ffi::XK_Henkan_Mode => events::VirtualKeyCode::Henkan_mode,
        //ffi::XK_Henkan => events::VirtualKeyCode::Henkan,
        //ffi::XK_Romaji => events::VirtualKeyCode::Romaji,
        //ffi::XK_Hiragana => events::VirtualKeyCode::Hiragana,
        //ffi::XK_Katakana => events::VirtualKeyCode::Katakana,
        //ffi::XK_Hiragana_Katakana => events::VirtualKeyCode::Hiragana_katakana,
        //ffi::XK_Zenkaku => events::VirtualKeyCode::Zenkaku,
        //ffi::XK_Hankaku => events::VirtualKeyCode::Hankaku,
        //ffi::XK_Zenkaku_Hankaku => events::VirtualKeyCode::Zenkaku_hankaku,
        //ffi::XK_Touroku => events::VirtualKeyCode::Touroku,
        //ffi::XK_Massyo => events::VirtualKeyCode::Massyo,
        //ffi::XK_Kana_Lock => events::VirtualKeyCode::Kana_lock,
        //ffi::XK_Kana_Shift => events::VirtualKeyCode::Kana_shift,
        //ffi::XK_Eisu_Shift => events::VirtualKeyCode::Eisu_shift,
        //ffi::XK_Eisu_toggle => events::VirtualKeyCode::Eisu_toggle,
        ffi::XK_Home => events::VirtualKeyCode::Home,
        ffi::XK_Left => events::VirtualKeyCode::Left,
        ffi::XK_Up => events::VirtualKeyCode::Up,
        ffi::XK_Right => events::VirtualKeyCode::Right,
        ffi::XK_Down => events::VirtualKeyCode::Down,
        //ffi::XK_Prior => events::VirtualKeyCode::Prior,
        ffi::XK_Page_Up => events::VirtualKeyCode::PageUp,
        //ffi::XK_Next => events::VirtualKeyCode::Next,
        ffi::XK_Page_Down => events::VirtualKeyCode::PageDown,
        ffi::XK_End => events::VirtualKeyCode::End,
        //ffi::XK_Begin => events::VirtualKeyCode::Begin,
        //ffi::XK_Win_L => events::VirtualKeyCode::Win_l,
        //ffi::XK_Win_R => events::VirtualKeyCode::Win_r,
        //ffi::XK_App => events::VirtualKeyCode::App,
        //ffi::XK_Select => events::VirtualKeyCode::Select,
        //ffi::XK_Print => events::VirtualKeyCode::Print,
        //ffi::XK_Execute => events::VirtualKeyCode::Execute,
        ffi::XK_Insert => events::VirtualKeyCode::Insert,
        //ffi::XK_Undo => events::VirtualKeyCode::Undo,
        //ffi::XK_Redo => events::VirtualKeyCode::Redo,
        //ffi::XK_Menu => events::VirtualKeyCode::Menu,
        //ffi::XK_Find => events::VirtualKeyCode::Find,
        //ffi::XK_Cancel => events::VirtualKeyCode::Cancel,
        //ffi::XK_Help => events::VirtualKeyCode::Help,
        //ffi::XK_Break => events::VirtualKeyCode::Break,
        //ffi::XK_Mode_switch => events::VirtualKeyCode::Mode_switch,
        //ffi::XK_script_switch => events::VirtualKeyCode::Script_switch,
        //ffi::XK_Num_Lock => events::VirtualKeyCode::Num_lock,
        //ffi::XK_KP_Space => events::VirtualKeyCode::Kp_space,
        //ffi::XK_KP_Tab => events::VirtualKeyCode::Kp_tab,
        //ffi::XK_KP_Enter => events::VirtualKeyCode::Kp_enter,
        //ffi::XK_KP_F1 => events::VirtualKeyCode::Kp_f1,
        //ffi::XK_KP_F2 => events::VirtualKeyCode::Kp_f2,
        //ffi::XK_KP_F3 => events::VirtualKeyCode::Kp_f3,
        //ffi::XK_KP_F4 => events::VirtualKeyCode::Kp_f4,
        ffi::XK_KP_Home => events::VirtualKeyCode::Home,
        ffi::XK_KP_Left => events::VirtualKeyCode::Left,
        ffi::XK_KP_Up => events::VirtualKeyCode::Up,
        ffi::XK_KP_Right => events::VirtualKeyCode::Right,
        ffi::XK_KP_Down => events::VirtualKeyCode::Down,
        //ffi::XK_KP_Prior => events::VirtualKeyCode::Kp_prior,
        ffi::XK_KP_Page_Up => events::VirtualKeyCode::PageUp,
        //ffi::XK_KP_Next => events::VirtualKeyCode::Kp_next,
        ffi::XK_KP_Page_Down => events::VirtualKeyCode::PageDown,
        ffi::XK_KP_End => events::VirtualKeyCode::End,
        //ffi::XK_KP_Begin => events::VirtualKeyCode::Kp_begin,
        ffi::XK_KP_Insert => events::VirtualKeyCode::Insert,
        ffi::XK_KP_Delete => events::VirtualKeyCode::Delete,
        ffi::XK_KP_Equal => events::VirtualKeyCode::NumpadEquals,
        //ffi::XK_KP_Multiply => events::VirtualKeyCode::NumpadMultiply,
        //ffi::XK_KP_Add => events::VirtualKeyCode::NumpadAdd,
        //ffi::XK_KP_Separator => events::VirtualKeyCode::Kp_separator,
        //ffi::XK_KP_Subtract => events::VirtualKeyCode::NumpadSubtract,
        //ffi::XK_KP_Decimal => events::VirtualKeyCode::Kp_decimal,
        //ffi::XK_KP_Divide => events::VirtualKeyCode::NumpadDivide,
        ffi::XK_KP_0 => events::VirtualKeyCode::Numpad0,
        ffi::XK_KP_1 => events::VirtualKeyCode::Numpad1,
        ffi::XK_KP_2 => events::VirtualKeyCode::Numpad2,
        ffi::XK_KP_3 => events::VirtualKeyCode::Numpad3,
        ffi::XK_KP_4 => events::VirtualKeyCode::Numpad4,
        ffi::XK_KP_5 => events::VirtualKeyCode::Numpad5,
        ffi::XK_KP_6 => events::VirtualKeyCode::Numpad6,
        ffi::XK_KP_7 => events::VirtualKeyCode::Numpad7,
        ffi::XK_KP_8 => events::VirtualKeyCode::Numpad8,
        ffi::XK_KP_9 => events::VirtualKeyCode::Numpad9,
        ffi::XK_F1 => events::VirtualKeyCode::F1,
        ffi::XK_F2 => events::VirtualKeyCode::F2,
        ffi::XK_F3 => events::VirtualKeyCode::F3,
        ffi::XK_F4 => events::VirtualKeyCode::F4,
        ffi::XK_F5 => events::VirtualKeyCode::F5,
        ffi::XK_F6 => events::VirtualKeyCode::F6,
        ffi::XK_F7 => events::VirtualKeyCode::F7,
        ffi::XK_F8 => events::VirtualKeyCode::F8,
        ffi::XK_F9 => events::VirtualKeyCode::F9,
        ffi::XK_F10 => events::VirtualKeyCode::F10,
        ffi::XK_F11 => events::VirtualKeyCode::F11,
        //ffi::XK_L1 => events::VirtualKeyCode::L1,
        ffi::XK_F12 => events::VirtualKeyCode::F12,
        //ffi::XK_L2 => events::VirtualKeyCode::L2,
        ffi::XK_F13 => events::VirtualKeyCode::F13,
        //ffi::XK_L3 => events::VirtualKeyCode::L3,
        ffi::XK_F14 => events::VirtualKeyCode::F14,
        //ffi::XK_L4 => events::VirtualKeyCode::L4,
        ffi::XK_F15 => events::VirtualKeyCode::F15,
        //ffi::XK_L5 => events::VirtualKeyCode::L5,
        //ffi::XK_F16 => events::VirtualKeyCode::F16,
        //ffi::XK_L6 => events::VirtualKeyCode::L6,
        //ffi::XK_F17 => events::VirtualKeyCode::F17,
        //ffi::XK_L7 => events::VirtualKeyCode::L7,
        //ffi::XK_F18 => events::VirtualKeyCode::F18,
        //ffi::XK_L8 => events::VirtualKeyCode::L8,
        //ffi::XK_F19 => events::VirtualKeyCode::F19,
        //ffi::XK_L9 => events::VirtualKeyCode::L9,
        //ffi::XK_F20 => events::VirtualKeyCode::F20,
        //ffi::XK_L10 => events::VirtualKeyCode::L10,
        //ffi::XK_F21 => events::VirtualKeyCode::F21,
        //ffi::XK_R1 => events::VirtualKeyCode::R1,
        //ffi::XK_F22 => events::VirtualKeyCode::F22,
        //ffi::XK_R2 => events::VirtualKeyCode::R2,
        //ffi::XK_F23 => events::VirtualKeyCode::F23,
        //ffi::XK_R3 => events::VirtualKeyCode::R3,
        //ffi::XK_F24 => events::VirtualKeyCode::F24,
        //ffi::XK_R4 => events::VirtualKeyCode::R4,
        //ffi::XK_F25 => events::VirtualKeyCode::F25,
        //ffi::XK_R5 => events::VirtualKeyCode::R5,
        //ffi::XK_F26 => events::VirtualKeyCode::F26,
        //ffi::XK_R6 => events::VirtualKeyCode::R6,
        //ffi::XK_F27 => events::VirtualKeyCode::F27,
        //ffi::XK_R7 => events::VirtualKeyCode::R7,
        //ffi::XK_F28 => events::VirtualKeyCode::F28,
        //ffi::XK_R8 => events::VirtualKeyCode::R8,
        //ffi::XK_F29 => events::VirtualKeyCode::F29,
        //ffi::XK_R9 => events::VirtualKeyCode::R9,
        //ffi::XK_F30 => events::VirtualKeyCode::F30,
        //ffi::XK_R10 => events::VirtualKeyCode::R10,
        //ffi::XK_F31 => events::VirtualKeyCode::F31,
        //ffi::XK_R11 => events::VirtualKeyCode::R11,
        //ffi::XK_F32 => events::VirtualKeyCode::F32,
        //ffi::XK_R12 => events::VirtualKeyCode::R12,
        //ffi::XK_F33 => events::VirtualKeyCode::F33,
        //ffi::XK_R13 => events::VirtualKeyCode::R13,
        //ffi::XK_F34 => events::VirtualKeyCode::F34,
        //ffi::XK_R14 => events::VirtualKeyCode::R14,
        //ffi::XK_F35 => events::VirtualKeyCode::F35,
        //ffi::XK_R15 => events::VirtualKeyCode::R15,
        ffi::XK_Shift_L => events::VirtualKeyCode::LShift,
        ffi::XK_Shift_R => events::VirtualKeyCode::RShift,
        ffi::XK_Control_L => events::VirtualKeyCode::LControl,
        ffi::XK_Control_R => events::VirtualKeyCode::RControl,
        //ffi::XK_Caps_Lock => events::VirtualKeyCode::Caps_lock,
        //ffi::XK_Shift_Lock => events::VirtualKeyCode::Shift_lock,
        //ffi::XK_Meta_L => events::VirtualKeyCode::Meta_l,
        //ffi::XK_Meta_R => events::VirtualKeyCode::Meta_r,
        ffi::XK_Alt_L => events::VirtualKeyCode::LAlt,
        ffi::XK_Alt_R => events::VirtualKeyCode::RAlt,
        //ffi::XK_Super_L => events::VirtualKeyCode::Super_l,
        //ffi::XK_Super_R => events::VirtualKeyCode::Super_r,
        //ffi::XK_Hyper_L => events::VirtualKeyCode::Hyper_l,
        //ffi::XK_Hyper_R => events::VirtualKeyCode::Hyper_r,
        ffi::XK_ISO_Left_Tab => events::VirtualKeyCode::Tab,
        ffi::XK_space => events::VirtualKeyCode::Space,
        //ffi::XK_exclam => events::VirtualKeyCode::Exclam,
        //ffi::XK_quotedbl => events::VirtualKeyCode::Quotedbl,
        //ffi::XK_numbersign => events::VirtualKeyCode::Numbersign,
        //ffi::XK_dollar => events::VirtualKeyCode::Dollar,
        //ffi::XK_percent => events::VirtualKeyCode::Percent,
        //ffi::XK_ampersand => events::VirtualKeyCode::Ampersand,
        ffi::XK_apostrophe => events::VirtualKeyCode::Apostrophe,
        //ffi::XK_quoteright => events::VirtualKeyCode::Quoteright,
        //ffi::XK_parenleft => events::VirtualKeyCode::Parenleft,
        //ffi::XK_parenright => events::VirtualKeyCode::Parenright,
        //ffi::XK_asterisk => events::VirtualKeyCode::Asterisk,
        ffi::XK_plus => events::VirtualKeyCode::Add,
        ffi::XK_comma => events::VirtualKeyCode::Comma,
        ffi::XK_minus => events::VirtualKeyCode::Subtract,
        ffi::XK_period => events::VirtualKeyCode::Period,
        ffi::XK_slash => events::VirtualKeyCode::Slash,
        ffi::XK_0 => events::VirtualKeyCode::Key0,
        ffi::XK_1 => events::VirtualKeyCode::Key1,
        ffi::XK_2 => events::VirtualKeyCode::Key2,
        ffi::XK_3 => events::VirtualKeyCode::Key3,
        ffi::XK_4 => events::VirtualKeyCode::Key4,
        ffi::XK_5 => events::VirtualKeyCode::Key5,
        ffi::XK_6 => events::VirtualKeyCode::Key6,
        ffi::XK_7 => events::VirtualKeyCode::Key7,
        ffi::XK_8 => events::VirtualKeyCode::Key8,
        ffi::XK_9 => events::VirtualKeyCode::Key9,
        ffi::XK_colon => events::VirtualKeyCode::Colon,
        ffi::XK_semicolon => events::VirtualKeyCode::Semicolon,
        //ffi::XK_less => events::VirtualKeyCode::Less,
        ffi::XK_equal => events::VirtualKeyCode::Equals,
        //ffi::XK_greater => events::VirtualKeyCode::Greater,
        //ffi::XK_question => events::VirtualKeyCode::Question,
        ffi::XK_at => events::VirtualKeyCode::At,
        ffi::XK_A => events::VirtualKeyCode::A,
        ffi::XK_B => events::VirtualKeyCode::B,
        ffi::XK_C => events::VirtualKeyCode::C,
        ffi::XK_D => events::VirtualKeyCode::D,
        ffi::XK_E => events::VirtualKeyCode::E,
        ffi::XK_F => events::VirtualKeyCode::F,
        ffi::XK_G => events::VirtualKeyCode::G,
        ffi::XK_H => events::VirtualKeyCode::H,
        ffi::XK_I => events::VirtualKeyCode::I,
        ffi::XK_J => events::VirtualKeyCode::J,
        ffi::XK_K => events::VirtualKeyCode::K,
        ffi::XK_L => events::VirtualKeyCode::L,
        ffi::XK_M => events::VirtualKeyCode::M,
        ffi::XK_N => events::VirtualKeyCode::N,
        ffi::XK_O => events::VirtualKeyCode::O,
        ffi::XK_P => events::VirtualKeyCode::P,
        ffi::XK_Q => events::VirtualKeyCode::Q,
        ffi::XK_R => events::VirtualKeyCode::R,
        ffi::XK_S => events::VirtualKeyCode::S,
        ffi::XK_T => events::VirtualKeyCode::T,
        ffi::XK_U => events::VirtualKeyCode::U,
        ffi::XK_V => events::VirtualKeyCode::V,
        ffi::XK_W => events::VirtualKeyCode::W,
        ffi::XK_X => events::VirtualKeyCode::X,
        ffi::XK_Y => events::VirtualKeyCode::Y,
        ffi::XK_Z => events::VirtualKeyCode::Z,
        ffi::XK_bracketleft => events::VirtualKeyCode::LBracket,
        ffi::XK_backslash => events::VirtualKeyCode::Backslash,
        ffi::XK_bracketright => events::VirtualKeyCode::RBracket,
        //ffi::XK_asciicircum => events::VirtualKeyCode::Asciicircum,
        //ffi::XK_underscore => events::VirtualKeyCode::Underscore,
        ffi::XK_grave => events::VirtualKeyCode::Grave,
        //ffi::XK_quoteleft => events::VirtualKeyCode::Quoteleft,
        ffi::XK_a => events::VirtualKeyCode::A,
        ffi::XK_b => events::VirtualKeyCode::B,
        ffi::XK_c => events::VirtualKeyCode::C,
        ffi::XK_d => events::VirtualKeyCode::D,
        ffi::XK_e => events::VirtualKeyCode::E,
        ffi::XK_f => events::VirtualKeyCode::F,
        ffi::XK_g => events::VirtualKeyCode::G,
        ffi::XK_h => events::VirtualKeyCode::H,
        ffi::XK_i => events::VirtualKeyCode::I,
        ffi::XK_j => events::VirtualKeyCode::J,
        ffi::XK_k => events::VirtualKeyCode::K,
        ffi::XK_l => events::VirtualKeyCode::L,
        ffi::XK_m => events::VirtualKeyCode::M,
        ffi::XK_n => events::VirtualKeyCode::N,
        ffi::XK_o => events::VirtualKeyCode::O,
        ffi::XK_p => events::VirtualKeyCode::P,
        ffi::XK_q => events::VirtualKeyCode::Q,
        ffi::XK_r => events::VirtualKeyCode::R,
        ffi::XK_s => events::VirtualKeyCode::S,
        ffi::XK_t => events::VirtualKeyCode::T,
        ffi::XK_u => events::VirtualKeyCode::U,
        ffi::XK_v => events::VirtualKeyCode::V,
        ffi::XK_w => events::VirtualKeyCode::W,
        ffi::XK_x => events::VirtualKeyCode::X,
        ffi::XK_y => events::VirtualKeyCode::Y,
        ffi::XK_z => events::VirtualKeyCode::Z,
        //ffi::XK_braceleft => events::VirtualKeyCode::Braceleft,
        //ffi::XK_bar => events::VirtualKeyCode::Bar,
        //ffi::XK_braceright => events::VirtualKeyCode::Braceright,
        //ffi::XK_asciitilde => events::VirtualKeyCode::Asciitilde,
        //ffi::XK_nobreakspace => events::VirtualKeyCode::Nobreakspace,
        //ffi::XK_exclamdown => events::VirtualKeyCode::Exclamdown,
        //ffi::XK_cent => events::VirtualKeyCode::Cent,
        //ffi::XK_sterling => events::VirtualKeyCode::Sterling,
        //ffi::XK_currency => events::VirtualKeyCode::Currency,
        //ffi::XK_yen => events::VirtualKeyCode::Yen,
        //ffi::XK_brokenbar => events::VirtualKeyCode::Brokenbar,
        //ffi::XK_section => events::VirtualKeyCode::Section,
        //ffi::XK_diaeresis => events::VirtualKeyCode::Diaeresis,
        //ffi::XK_copyright => events::VirtualKeyCode::Copyright,
        //ffi::XK_ordfeminine => events::VirtualKeyCode::Ordfeminine,
        //ffi::XK_guillemotleft => events::VirtualKeyCode::Guillemotleft,
        //ffi::XK_notsign => events::VirtualKeyCode::Notsign,
        //ffi::XK_hyphen => events::VirtualKeyCode::Hyphen,
        //ffi::XK_registered => events::VirtualKeyCode::Registered,
        //ffi::XK_macron => events::VirtualKeyCode::Macron,
        //ffi::XK_degree => events::VirtualKeyCode::Degree,
        //ffi::XK_plusminus => events::VirtualKeyCode::Plusminus,
        //ffi::XK_twosuperior => events::VirtualKeyCode::Twosuperior,
        //ffi::XK_threesuperior => events::VirtualKeyCode::Threesuperior,
        //ffi::XK_acute => events::VirtualKeyCode::Acute,
        //ffi::XK_mu => events::VirtualKeyCode::Mu,
        //ffi::XK_paragraph => events::VirtualKeyCode::Paragraph,
        //ffi::XK_periodcentered => events::VirtualKeyCode::Periodcentered,
        //ffi::XK_cedilla => events::VirtualKeyCode::Cedilla,
        //ffi::XK_onesuperior => events::VirtualKeyCode::Onesuperior,
        //ffi::XK_masculine => events::VirtualKeyCode::Masculine,
        //ffi::XK_guillemotright => events::VirtualKeyCode::Guillemotright,
        //ffi::XK_onequarter => events::VirtualKeyCode::Onequarter,
        //ffi::XK_onehalf => events::VirtualKeyCode::Onehalf,
        //ffi::XK_threequarters => events::VirtualKeyCode::Threequarters,
        //ffi::XK_questiondown => events::VirtualKeyCode::Questiondown,
        //ffi::XK_Agrave => events::VirtualKeyCode::Agrave,
        //ffi::XK_Aacute => events::VirtualKeyCode::Aacute,
        //ffi::XK_Acircumflex => events::VirtualKeyCode::Acircumflex,
        //ffi::XK_Atilde => events::VirtualKeyCode::Atilde,
        //ffi::XK_Adiaeresis => events::VirtualKeyCode::Adiaeresis,
        //ffi::XK_Aring => events::VirtualKeyCode::Aring,
        //ffi::XK_AE => events::VirtualKeyCode::Ae,
        //ffi::XK_Ccedilla => events::VirtualKeyCode::Ccedilla,
        //ffi::XK_Egrave => events::VirtualKeyCode::Egrave,
        //ffi::XK_Eacute => events::VirtualKeyCode::Eacute,
        //ffi::XK_Ecircumflex => events::VirtualKeyCode::Ecircumflex,
        //ffi::XK_Ediaeresis => events::VirtualKeyCode::Ediaeresis,
        //ffi::XK_Igrave => events::VirtualKeyCode::Igrave,
        //ffi::XK_Iacute => events::VirtualKeyCode::Iacute,
        //ffi::XK_Icircumflex => events::VirtualKeyCode::Icircumflex,
        //ffi::XK_Idiaeresis => events::VirtualKeyCode::Idiaeresis,
        //ffi::XK_ETH => events::VirtualKeyCode::Eth,
        //ffi::XK_Eth => events::VirtualKeyCode::Eth,
        //ffi::XK_Ntilde => events::VirtualKeyCode::Ntilde,
        //ffi::XK_Ograve => events::VirtualKeyCode::Ograve,
        //ffi::XK_Oacute => events::VirtualKeyCode::Oacute,
        //ffi::XK_Ocircumflex => events::VirtualKeyCode::Ocircumflex,
        //ffi::XK_Otilde => events::VirtualKeyCode::Otilde,
        //ffi::XK_Odiaeresis => events::VirtualKeyCode::Odiaeresis,
        //ffi::XK_multiply => events::VirtualKeyCode::Multiply,
        //ffi::XK_Ooblique => events::VirtualKeyCode::Ooblique,
        //ffi::XK_Ugrave => events::VirtualKeyCode::Ugrave,
        //ffi::XK_Uacute => events::VirtualKeyCode::Uacute,
        //ffi::XK_Ucircumflex => events::VirtualKeyCode::Ucircumflex,
        //ffi::XK_Udiaeresis => events::VirtualKeyCode::Udiaeresis,
        //ffi::XK_Yacute => events::VirtualKeyCode::Yacute,
        //ffi::XK_THORN => events::VirtualKeyCode::Thorn,
        //ffi::XK_Thorn => events::VirtualKeyCode::Thorn,
        //ffi::XK_ssharp => events::VirtualKeyCode::Ssharp,
        //ffi::XK_agrave => events::VirtualKeyCode::Agrave,
        //ffi::XK_aacute => events::VirtualKeyCode::Aacute,
        //ffi::XK_acircumflex => events::VirtualKeyCode::Acircumflex,
        //ffi::XK_atilde => events::VirtualKeyCode::Atilde,
        //ffi::XK_adiaeresis => events::VirtualKeyCode::Adiaeresis,
        //ffi::XK_aring => events::VirtualKeyCode::Aring,
        //ffi::XK_ae => events::VirtualKeyCode::Ae,
        //ffi::XK_ccedilla => events::VirtualKeyCode::Ccedilla,
        //ffi::XK_egrave => events::VirtualKeyCode::Egrave,
        //ffi::XK_eacute => events::VirtualKeyCode::Eacute,
        //ffi::XK_ecircumflex => events::VirtualKeyCode::Ecircumflex,
        //ffi::XK_ediaeresis => events::VirtualKeyCode::Ediaeresis,
        //ffi::XK_igrave => events::VirtualKeyCode::Igrave,
        //ffi::XK_iacute => events::VirtualKeyCode::Iacute,
        //ffi::XK_icircumflex => events::VirtualKeyCode::Icircumflex,
        //ffi::XK_idiaeresis => events::VirtualKeyCode::Idiaeresis,
        //ffi::XK_eth => events::VirtualKeyCode::Eth,
        //ffi::XK_ntilde => events::VirtualKeyCode::Ntilde,
        //ffi::XK_ograve => events::VirtualKeyCode::Ograve,
        //ffi::XK_oacute => events::VirtualKeyCode::Oacute,
        //ffi::XK_ocircumflex => events::VirtualKeyCode::Ocircumflex,
        //ffi::XK_otilde => events::VirtualKeyCode::Otilde,
        //ffi::XK_odiaeresis => events::VirtualKeyCode::Odiaeresis,
        //ffi::XK_division => events::VirtualKeyCode::Division,
        //ffi::XK_oslash => events::VirtualKeyCode::Oslash,
        //ffi::XK_ugrave => events::VirtualKeyCode::Ugrave,
        //ffi::XK_uacute => events::VirtualKeyCode::Uacute,
        //ffi::XK_ucircumflex => events::VirtualKeyCode::Ucircumflex,
        //ffi::XK_udiaeresis => events::VirtualKeyCode::Udiaeresis,
        //ffi::XK_yacute => events::VirtualKeyCode::Yacute,
        //ffi::XK_thorn => events::VirtualKeyCode::Thorn,
        //ffi::XK_ydiaeresis => events::VirtualKeyCode::Ydiaeresis,
        //ffi::XK_Aogonek => events::VirtualKeyCode::Aogonek,
        //ffi::XK_breve => events::VirtualKeyCode::Breve,
        //ffi::XK_Lstroke => events::VirtualKeyCode::Lstroke,
        //ffi::XK_Lcaron => events::VirtualKeyCode::Lcaron,
        //ffi::XK_Sacute => events::VirtualKeyCode::Sacute,
        //ffi::XK_Scaron => events::VirtualKeyCode::Scaron,
        //ffi::XK_Scedilla => events::VirtualKeyCode::Scedilla,
        //ffi::XK_Tcaron => events::VirtualKeyCode::Tcaron,
        //ffi::XK_Zacute => events::VirtualKeyCode::Zacute,
        //ffi::XK_Zcaron => events::VirtualKeyCode::Zcaron,
        //ffi::XK_Zabovedot => events::VirtualKeyCode::Zabovedot,
        //ffi::XK_aogonek => events::VirtualKeyCode::Aogonek,
        //ffi::XK_ogonek => events::VirtualKeyCode::Ogonek,
        //ffi::XK_lstroke => events::VirtualKeyCode::Lstroke,
        //ffi::XK_lcaron => events::VirtualKeyCode::Lcaron,
        //ffi::XK_sacute => events::VirtualKeyCode::Sacute,
        //ffi::XK_caron => events::VirtualKeyCode::Caron,
        //ffi::XK_scaron => events::VirtualKeyCode::Scaron,
        //ffi::XK_scedilla => events::VirtualKeyCode::Scedilla,
        //ffi::XK_tcaron => events::VirtualKeyCode::Tcaron,
        //ffi::XK_zacute => events::VirtualKeyCode::Zacute,
        //ffi::XK_doubleacute => events::VirtualKeyCode::Doubleacute,
        //ffi::XK_zcaron => events::VirtualKeyCode::Zcaron,
        //ffi::XK_zabovedot => events::VirtualKeyCode::Zabovedot,
        //ffi::XK_Racute => events::VirtualKeyCode::Racute,
        //ffi::XK_Abreve => events::VirtualKeyCode::Abreve,
        //ffi::XK_Lacute => events::VirtualKeyCode::Lacute,
        //ffi::XK_Cacute => events::VirtualKeyCode::Cacute,
        //ffi::XK_Ccaron => events::VirtualKeyCode::Ccaron,
        //ffi::XK_Eogonek => events::VirtualKeyCode::Eogonek,
        //ffi::XK_Ecaron => events::VirtualKeyCode::Ecaron,
        //ffi::XK_Dcaron => events::VirtualKeyCode::Dcaron,
        //ffi::XK_Dstroke => events::VirtualKeyCode::Dstroke,
        //ffi::XK_Nacute => events::VirtualKeyCode::Nacute,
        //ffi::XK_Ncaron => events::VirtualKeyCode::Ncaron,
        //ffi::XK_Odoubleacute => events::VirtualKeyCode::Odoubleacute,
        //ffi::XK_Rcaron => events::VirtualKeyCode::Rcaron,
        //ffi::XK_Uring => events::VirtualKeyCode::Uring,
        //ffi::XK_Udoubleacute => events::VirtualKeyCode::Udoubleacute,
        //ffi::XK_Tcedilla => events::VirtualKeyCode::Tcedilla,
        //ffi::XK_racute => events::VirtualKeyCode::Racute,
        //ffi::XK_abreve => events::VirtualKeyCode::Abreve,
        //ffi::XK_lacute => events::VirtualKeyCode::Lacute,
        //ffi::XK_cacute => events::VirtualKeyCode::Cacute,
        //ffi::XK_ccaron => events::VirtualKeyCode::Ccaron,
        //ffi::XK_eogonek => events::VirtualKeyCode::Eogonek,
        //ffi::XK_ecaron => events::VirtualKeyCode::Ecaron,
        //ffi::XK_dcaron => events::VirtualKeyCode::Dcaron,
        //ffi::XK_dstroke => events::VirtualKeyCode::Dstroke,
        //ffi::XK_nacute => events::VirtualKeyCode::Nacute,
        //ffi::XK_ncaron => events::VirtualKeyCode::Ncaron,
        //ffi::XK_odoubleacute => events::VirtualKeyCode::Odoubleacute,
        //ffi::XK_udoubleacute => events::VirtualKeyCode::Udoubleacute,
        //ffi::XK_rcaron => events::VirtualKeyCode::Rcaron,
        //ffi::XK_uring => events::VirtualKeyCode::Uring,
        //ffi::XK_tcedilla => events::VirtualKeyCode::Tcedilla,
        //ffi::XK_abovedot => events::VirtualKeyCode::Abovedot,
        //ffi::XK_Hstroke => events::VirtualKeyCode::Hstroke,
        //ffi::XK_Hcircumflex => events::VirtualKeyCode::Hcircumflex,
        //ffi::XK_Iabovedot => events::VirtualKeyCode::Iabovedot,
        //ffi::XK_Gbreve => events::VirtualKeyCode::Gbreve,
        //ffi::XK_Jcircumflex => events::VirtualKeyCode::Jcircumflex,
        //ffi::XK_hstroke => events::VirtualKeyCode::Hstroke,
        //ffi::XK_hcircumflex => events::VirtualKeyCode::Hcircumflex,
        //ffi::XK_idotless => events::VirtualKeyCode::Idotless,
        //ffi::XK_gbreve => events::VirtualKeyCode::Gbreve,
        //ffi::XK_jcircumflex => events::VirtualKeyCode::Jcircumflex,
        //ffi::XK_Cabovedot => events::VirtualKeyCode::Cabovedot,
        //ffi::XK_Ccircumflex => events::VirtualKeyCode::Ccircumflex,
        //ffi::XK_Gabovedot => events::VirtualKeyCode::Gabovedot,
        //ffi::XK_Gcircumflex => events::VirtualKeyCode::Gcircumflex,
        //ffi::XK_Ubreve => events::VirtualKeyCode::Ubreve,
        //ffi::XK_Scircumflex => events::VirtualKeyCode::Scircumflex,
        //ffi::XK_cabovedot => events::VirtualKeyCode::Cabovedot,
        //ffi::XK_ccircumflex => events::VirtualKeyCode::Ccircumflex,
        //ffi::XK_gabovedot => events::VirtualKeyCode::Gabovedot,
        //ffi::XK_gcircumflex => events::VirtualKeyCode::Gcircumflex,
        //ffi::XK_ubreve => events::VirtualKeyCode::Ubreve,
        //ffi::XK_scircumflex => events::VirtualKeyCode::Scircumflex,
        //ffi::XK_kra => events::VirtualKeyCode::Kra,
        //ffi::XK_kappa => events::VirtualKeyCode::Kappa,
        //ffi::XK_Rcedilla => events::VirtualKeyCode::Rcedilla,
        //ffi::XK_Itilde => events::VirtualKeyCode::Itilde,
        //ffi::XK_Lcedilla => events::VirtualKeyCode::Lcedilla,
        //ffi::XK_Emacron => events::VirtualKeyCode::Emacron,
        //ffi::XK_Gcedilla => events::VirtualKeyCode::Gcedilla,
        //ffi::XK_Tslash => events::VirtualKeyCode::Tslash,
        //ffi::XK_rcedilla => events::VirtualKeyCode::Rcedilla,
        //ffi::XK_itilde => events::VirtualKeyCode::Itilde,
        //ffi::XK_lcedilla => events::VirtualKeyCode::Lcedilla,
        //ffi::XK_emacron => events::VirtualKeyCode::Emacron,
        //ffi::XK_gcedilla => events::VirtualKeyCode::Gcedilla,
        //ffi::XK_tslash => events::VirtualKeyCode::Tslash,
        //ffi::XK_ENG => events::VirtualKeyCode::Eng,
        //ffi::XK_eng => events::VirtualKeyCode::Eng,
        //ffi::XK_Amacron => events::VirtualKeyCode::Amacron,
        //ffi::XK_Iogonek => events::VirtualKeyCode::Iogonek,
        //ffi::XK_Eabovedot => events::VirtualKeyCode::Eabovedot,
        //ffi::XK_Imacron => events::VirtualKeyCode::Imacron,
        //ffi::XK_Ncedilla => events::VirtualKeyCode::Ncedilla,
        //ffi::XK_Omacron => events::VirtualKeyCode::Omacron,
        //ffi::XK_Kcedilla => events::VirtualKeyCode::Kcedilla,
        //ffi::XK_Uogonek => events::VirtualKeyCode::Uogonek,
        //ffi::XK_Utilde => events::VirtualKeyCode::Utilde,
        //ffi::XK_Umacron => events::VirtualKeyCode::Umacron,
        //ffi::XK_amacron => events::VirtualKeyCode::Amacron,
        //ffi::XK_iogonek => events::VirtualKeyCode::Iogonek,
        //ffi::XK_eabovedot => events::VirtualKeyCode::Eabovedot,
        //ffi::XK_imacron => events::VirtualKeyCode::Imacron,
        //ffi::XK_ncedilla => events::VirtualKeyCode::Ncedilla,
        //ffi::XK_omacron => events::VirtualKeyCode::Omacron,
        //ffi::XK_kcedilla => events::VirtualKeyCode::Kcedilla,
        //ffi::XK_uogonek => events::VirtualKeyCode::Uogonek,
        //ffi::XK_utilde => events::VirtualKeyCode::Utilde,
        //ffi::XK_umacron => events::VirtualKeyCode::Umacron,
        //ffi::XK_overline => events::VirtualKeyCode::Overline,
        //ffi::XK_kana_fullstop => events::VirtualKeyCode::Kana_fullstop,
        //ffi::XK_kana_openingbracket => events::VirtualKeyCode::Kana_openingbracket,
        //ffi::XK_kana_closingbracket => events::VirtualKeyCode::Kana_closingbracket,
        //ffi::XK_kana_comma => events::VirtualKeyCode::Kana_comma,
        //ffi::XK_kana_conjunctive => events::VirtualKeyCode::Kana_conjunctive,
        //ffi::XK_kana_middledot => events::VirtualKeyCode::Kana_middledot,
        //ffi::XK_kana_WO => events::VirtualKeyCode::Kana_wo,
        //ffi::XK_kana_a => events::VirtualKeyCode::Kana_a,
        //ffi::XK_kana_i => events::VirtualKeyCode::Kana_i,
        //ffi::XK_kana_u => events::VirtualKeyCode::Kana_u,
        //ffi::XK_kana_e => events::VirtualKeyCode::Kana_e,
        //ffi::XK_kana_o => events::VirtualKeyCode::Kana_o,
        //ffi::XK_kana_ya => events::VirtualKeyCode::Kana_ya,
        //ffi::XK_kana_yu => events::VirtualKeyCode::Kana_yu,
        //ffi::XK_kana_yo => events::VirtualKeyCode::Kana_yo,
        //ffi::XK_kana_tsu => events::VirtualKeyCode::Kana_tsu,
        //ffi::XK_kana_tu => events::VirtualKeyCode::Kana_tu,
        //ffi::XK_prolongedsound => events::VirtualKeyCode::Prolongedsound,
        //ffi::XK_kana_A => events::VirtualKeyCode::Kana_a,
        //ffi::XK_kana_I => events::VirtualKeyCode::Kana_i,
        //ffi::XK_kana_U => events::VirtualKeyCode::Kana_u,
        //ffi::XK_kana_E => events::VirtualKeyCode::Kana_e,
        //ffi::XK_kana_O => events::VirtualKeyCode::Kana_o,
        //ffi::XK_kana_KA => events::VirtualKeyCode::Kana_ka,
        //ffi::XK_kana_KI => events::VirtualKeyCode::Kana_ki,
        //ffi::XK_kana_KU => events::VirtualKeyCode::Kana_ku,
        //ffi::XK_kana_KE => events::VirtualKeyCode::Kana_ke,
        //ffi::XK_kana_KO => events::VirtualKeyCode::Kana_ko,
        //ffi::XK_kana_SA => events::VirtualKeyCode::Kana_sa,
        //ffi::XK_kana_SHI => events::VirtualKeyCode::Kana_shi,
        //ffi::XK_kana_SU => events::VirtualKeyCode::Kana_su,
        //ffi::XK_kana_SE => events::VirtualKeyCode::Kana_se,
        //ffi::XK_kana_SO => events::VirtualKeyCode::Kana_so,
        //ffi::XK_kana_TA => events::VirtualKeyCode::Kana_ta,
        //ffi::XK_kana_CHI => events::VirtualKeyCode::Kana_chi,
        //ffi::XK_kana_TI => events::VirtualKeyCode::Kana_ti,
        //ffi::XK_kana_TSU => events::VirtualKeyCode::Kana_tsu,
        //ffi::XK_kana_TU => events::VirtualKeyCode::Kana_tu,
        //ffi::XK_kana_TE => events::VirtualKeyCode::Kana_te,
        //ffi::XK_kana_TO => events::VirtualKeyCode::Kana_to,
        //ffi::XK_kana_NA => events::VirtualKeyCode::Kana_na,
        //ffi::XK_kana_NI => events::VirtualKeyCode::Kana_ni,
        //ffi::XK_kana_NU => events::VirtualKeyCode::Kana_nu,
        //ffi::XK_kana_NE => events::VirtualKeyCode::Kana_ne,
        //ffi::XK_kana_NO => events::VirtualKeyCode::Kana_no,
        //ffi::XK_kana_HA => events::VirtualKeyCode::Kana_ha,
        //ffi::XK_kana_HI => events::VirtualKeyCode::Kana_hi,
        //ffi::XK_kana_FU => events::VirtualKeyCode::Kana_fu,
        //ffi::XK_kana_HU => events::VirtualKeyCode::Kana_hu,
        //ffi::XK_kana_HE => events::VirtualKeyCode::Kana_he,
        //ffi::XK_kana_HO => events::VirtualKeyCode::Kana_ho,
        //ffi::XK_kana_MA => events::VirtualKeyCode::Kana_ma,
        //ffi::XK_kana_MI => events::VirtualKeyCode::Kana_mi,
        //ffi::XK_kana_MU => events::VirtualKeyCode::Kana_mu,
        //ffi::XK_kana_ME => events::VirtualKeyCode::Kana_me,
        //ffi::XK_kana_MO => events::VirtualKeyCode::Kana_mo,
        //ffi::XK_kana_YA => events::VirtualKeyCode::Kana_ya,
        //ffi::XK_kana_YU => events::VirtualKeyCode::Kana_yu,
        //ffi::XK_kana_YO => events::VirtualKeyCode::Kana_yo,
        //ffi::XK_kana_RA => events::VirtualKeyCode::Kana_ra,
        //ffi::XK_kana_RI => events::VirtualKeyCode::Kana_ri,
        //ffi::XK_kana_RU => events::VirtualKeyCode::Kana_ru,
        //ffi::XK_kana_RE => events::VirtualKeyCode::Kana_re,
        //ffi::XK_kana_RO => events::VirtualKeyCode::Kana_ro,
        //ffi::XK_kana_WA => events::VirtualKeyCode::Kana_wa,
        //ffi::XK_kana_N => events::VirtualKeyCode::Kana_n,
        //ffi::XK_voicedsound => events::VirtualKeyCode::Voicedsound,
        //ffi::XK_semivoicedsound => events::VirtualKeyCode::Semivoicedsound,
        //ffi::XK_kana_switch => events::VirtualKeyCode::Kana_switch,
        //ffi::XK_Arabic_comma => events::VirtualKeyCode::Arabic_comma,
        //ffi::XK_Arabic_semicolon => events::VirtualKeyCode::Arabic_semicolon,
        //ffi::XK_Arabic_question_mark => events::VirtualKeyCode::Arabic_question_mark,
        //ffi::XK_Arabic_hamza => events::VirtualKeyCode::Arabic_hamza,
        //ffi::XK_Arabic_maddaonalef => events::VirtualKeyCode::Arabic_maddaonalef,
        //ffi::XK_Arabic_hamzaonalef => events::VirtualKeyCode::Arabic_hamzaonalef,
        //ffi::XK_Arabic_hamzaonwaw => events::VirtualKeyCode::Arabic_hamzaonwaw,
        //ffi::XK_Arabic_hamzaunderalef => events::VirtualKeyCode::Arabic_hamzaunderalef,
        //ffi::XK_Arabic_hamzaonyeh => events::VirtualKeyCode::Arabic_hamzaonyeh,
        //ffi::XK_Arabic_alef => events::VirtualKeyCode::Arabic_alef,
        //ffi::XK_Arabic_beh => events::VirtualKeyCode::Arabic_beh,
        //ffi::XK_Arabic_tehmarbuta => events::VirtualKeyCode::Arabic_tehmarbuta,
        //ffi::XK_Arabic_teh => events::VirtualKeyCode::Arabic_teh,
        //ffi::XK_Arabic_theh => events::VirtualKeyCode::Arabic_theh,
        //ffi::XK_Arabic_jeem => events::VirtualKeyCode::Arabic_jeem,
        //ffi::XK_Arabic_hah => events::VirtualKeyCode::Arabic_hah,
        //ffi::XK_Arabic_khah => events::VirtualKeyCode::Arabic_khah,
        //ffi::XK_Arabic_dal => events::VirtualKeyCode::Arabic_dal,
        //ffi::XK_Arabic_thal => events::VirtualKeyCode::Arabic_thal,
        //ffi::XK_Arabic_ra => events::VirtualKeyCode::Arabic_ra,
        //ffi::XK_Arabic_zain => events::VirtualKeyCode::Arabic_zain,
        //ffi::XK_Arabic_seen => events::VirtualKeyCode::Arabic_seen,
        //ffi::XK_Arabic_sheen => events::VirtualKeyCode::Arabic_sheen,
        //ffi::XK_Arabic_sad => events::VirtualKeyCode::Arabic_sad,
        //ffi::XK_Arabic_dad => events::VirtualKeyCode::Arabic_dad,
        //ffi::XK_Arabic_tah => events::VirtualKeyCode::Arabic_tah,
        //ffi::XK_Arabic_zah => events::VirtualKeyCode::Arabic_zah,
        //ffi::XK_Arabic_ain => events::VirtualKeyCode::Arabic_ain,
        //ffi::XK_Arabic_ghain => events::VirtualKeyCode::Arabic_ghain,
        //ffi::XK_Arabic_tatweel => events::VirtualKeyCode::Arabic_tatweel,
        //ffi::XK_Arabic_feh => events::VirtualKeyCode::Arabic_feh,
        //ffi::XK_Arabic_qaf => events::VirtualKeyCode::Arabic_qaf,
        //ffi::XK_Arabic_kaf => events::VirtualKeyCode::Arabic_kaf,
        //ffi::XK_Arabic_lam => events::VirtualKeyCode::Arabic_lam,
        //ffi::XK_Arabic_meem => events::VirtualKeyCode::Arabic_meem,
        //ffi::XK_Arabic_noon => events::VirtualKeyCode::Arabic_noon,
        //ffi::XK_Arabic_ha => events::VirtualKeyCode::Arabic_ha,
        //ffi::XK_Arabic_heh => events::VirtualKeyCode::Arabic_heh,
        //ffi::XK_Arabic_waw => events::VirtualKeyCode::Arabic_waw,
        //ffi::XK_Arabic_alefmaksura => events::VirtualKeyCode::Arabic_alefmaksura,
        //ffi::XK_Arabic_yeh => events::VirtualKeyCode::Arabic_yeh,
        //ffi::XK_Arabic_fathatan => events::VirtualKeyCode::Arabic_fathatan,
        //ffi::XK_Arabic_dammatan => events::VirtualKeyCode::Arabic_dammatan,
        //ffi::XK_Arabic_kasratan => events::VirtualKeyCode::Arabic_kasratan,
        //ffi::XK_Arabic_fatha => events::VirtualKeyCode::Arabic_fatha,
        //ffi::XK_Arabic_damma => events::VirtualKeyCode::Arabic_damma,
        //ffi::XK_Arabic_kasra => events::VirtualKeyCode::Arabic_kasra,
        //ffi::XK_Arabic_shadda => events::VirtualKeyCode::Arabic_shadda,
        //ffi::XK_Arabic_sukun => events::VirtualKeyCode::Arabic_sukun,
        //ffi::XK_Arabic_switch => events::VirtualKeyCode::Arabic_switch,
        //ffi::XK_Serbian_dje => events::VirtualKeyCode::Serbian_dje,
        //ffi::XK_Macedonia_gje => events::VirtualKeyCode::Macedonia_gje,
        //ffi::XK_Cyrillic_io => events::VirtualKeyCode::Cyrillic_io,
        //ffi::XK_Ukrainian_ie => events::VirtualKeyCode::Ukrainian_ie,
        //ffi::XK_Ukranian_je => events::VirtualKeyCode::Ukranian_je,
        //ffi::XK_Macedonia_dse => events::VirtualKeyCode::Macedonia_dse,
        //ffi::XK_Ukrainian_i => events::VirtualKeyCode::Ukrainian_i,
        //ffi::XK_Ukranian_i => events::VirtualKeyCode::Ukranian_i,
        //ffi::XK_Ukrainian_yi => events::VirtualKeyCode::Ukrainian_yi,
        //ffi::XK_Ukranian_yi => events::VirtualKeyCode::Ukranian_yi,
        //ffi::XK_Cyrillic_je => events::VirtualKeyCode::Cyrillic_je,
        //ffi::XK_Serbian_je => events::VirtualKeyCode::Serbian_je,
        //ffi::XK_Cyrillic_lje => events::VirtualKeyCode::Cyrillic_lje,
        //ffi::XK_Serbian_lje => events::VirtualKeyCode::Serbian_lje,
        //ffi::XK_Cyrillic_nje => events::VirtualKeyCode::Cyrillic_nje,
        //ffi::XK_Serbian_nje => events::VirtualKeyCode::Serbian_nje,
        //ffi::XK_Serbian_tshe => events::VirtualKeyCode::Serbian_tshe,
        //ffi::XK_Macedonia_kje => events::VirtualKeyCode::Macedonia_kje,
        //ffi::XK_Byelorussian_shortu => events::VirtualKeyCode::Byelorussian_shortu,
        //ffi::XK_Cyrillic_dzhe => events::VirtualKeyCode::Cyrillic_dzhe,
        //ffi::XK_Serbian_dze => events::VirtualKeyCode::Serbian_dze,
        //ffi::XK_numerosign => events::VirtualKeyCode::Numerosign,
        //ffi::XK_Serbian_DJE => events::VirtualKeyCode::Serbian_dje,
        //ffi::XK_Macedonia_GJE => events::VirtualKeyCode::Macedonia_gje,
        //ffi::XK_Cyrillic_IO => events::VirtualKeyCode::Cyrillic_io,
        //ffi::XK_Ukrainian_IE => events::VirtualKeyCode::Ukrainian_ie,
        //ffi::XK_Ukranian_JE => events::VirtualKeyCode::Ukranian_je,
        //ffi::XK_Macedonia_DSE => events::VirtualKeyCode::Macedonia_dse,
        //ffi::XK_Ukrainian_I => events::VirtualKeyCode::Ukrainian_i,
        //ffi::XK_Ukranian_I => events::VirtualKeyCode::Ukranian_i,
        //ffi::XK_Ukrainian_YI => events::VirtualKeyCode::Ukrainian_yi,
        //ffi::XK_Ukranian_YI => events::VirtualKeyCode::Ukranian_yi,
        //ffi::XK_Cyrillic_JE => events::VirtualKeyCode::Cyrillic_je,
        //ffi::XK_Serbian_JE => events::VirtualKeyCode::Serbian_je,
        //ffi::XK_Cyrillic_LJE => events::VirtualKeyCode::Cyrillic_lje,
        //ffi::XK_Serbian_LJE => events::VirtualKeyCode::Serbian_lje,
        //ffi::XK_Cyrillic_NJE => events::VirtualKeyCode::Cyrillic_nje,
        //ffi::XK_Serbian_NJE => events::VirtualKeyCode::Serbian_nje,
        //ffi::XK_Serbian_TSHE => events::VirtualKeyCode::Serbian_tshe,
        //ffi::XK_Macedonia_KJE => events::VirtualKeyCode::Macedonia_kje,
        //ffi::XK_Byelorussian_SHORTU => events::VirtualKeyCode::Byelorussian_shortu,
        //ffi::XK_Cyrillic_DZHE => events::VirtualKeyCode::Cyrillic_dzhe,
        //ffi::XK_Serbian_DZE => events::VirtualKeyCode::Serbian_dze,
        //ffi::XK_Cyrillic_yu => events::VirtualKeyCode::Cyrillic_yu,
        //ffi::XK_Cyrillic_a => events::VirtualKeyCode::Cyrillic_a,
        //ffi::XK_Cyrillic_be => events::VirtualKeyCode::Cyrillic_be,
        //ffi::XK_Cyrillic_tse => events::VirtualKeyCode::Cyrillic_tse,
        //ffi::XK_Cyrillic_de => events::VirtualKeyCode::Cyrillic_de,
        //ffi::XK_Cyrillic_ie => events::VirtualKeyCode::Cyrillic_ie,
        //ffi::XK_Cyrillic_ef => events::VirtualKeyCode::Cyrillic_ef,
        //ffi::XK_Cyrillic_ghe => events::VirtualKeyCode::Cyrillic_ghe,
        //ffi::XK_Cyrillic_ha => events::VirtualKeyCode::Cyrillic_ha,
        //ffi::XK_Cyrillic_i => events::VirtualKeyCode::Cyrillic_i,
        //ffi::XK_Cyrillic_shorti => events::VirtualKeyCode::Cyrillic_shorti,
        //ffi::XK_Cyrillic_ka => events::VirtualKeyCode::Cyrillic_ka,
        //ffi::XK_Cyrillic_el => events::VirtualKeyCode::Cyrillic_el,
        //ffi::XK_Cyrillic_em => events::VirtualKeyCode::Cyrillic_em,
        //ffi::XK_Cyrillic_en => events::VirtualKeyCode::Cyrillic_en,
        //ffi::XK_Cyrillic_o => events::VirtualKeyCode::Cyrillic_o,
        //ffi::XK_Cyrillic_pe => events::VirtualKeyCode::Cyrillic_pe,
        //ffi::XK_Cyrillic_ya => events::VirtualKeyCode::Cyrillic_ya,
        //ffi::XK_Cyrillic_er => events::VirtualKeyCode::Cyrillic_er,
        //ffi::XK_Cyrillic_es => events::VirtualKeyCode::Cyrillic_es,
        //ffi::XK_Cyrillic_te => events::VirtualKeyCode::Cyrillic_te,
        //ffi::XK_Cyrillic_u => events::VirtualKeyCode::Cyrillic_u,
        //ffi::XK_Cyrillic_zhe => events::VirtualKeyCode::Cyrillic_zhe,
        //ffi::XK_Cyrillic_ve => events::VirtualKeyCode::Cyrillic_ve,
        //ffi::XK_Cyrillic_softsign => events::VirtualKeyCode::Cyrillic_softsign,
        //ffi::XK_Cyrillic_yeru => events::VirtualKeyCode::Cyrillic_yeru,
        //ffi::XK_Cyrillic_ze => events::VirtualKeyCode::Cyrillic_ze,
        //ffi::XK_Cyrillic_sha => events::VirtualKeyCode::Cyrillic_sha,
        //ffi::XK_Cyrillic_e => events::VirtualKeyCode::Cyrillic_e,
        //ffi::XK_Cyrillic_shcha => events::VirtualKeyCode::Cyrillic_shcha,
        //ffi::XK_Cyrillic_che => events::VirtualKeyCode::Cyrillic_che,
        //ffi::XK_Cyrillic_hardsign => events::VirtualKeyCode::Cyrillic_hardsign,
        //ffi::XK_Cyrillic_YU => events::VirtualKeyCode::Cyrillic_yu,
        //ffi::XK_Cyrillic_A => events::VirtualKeyCode::Cyrillic_a,
        //ffi::XK_Cyrillic_BE => events::VirtualKeyCode::Cyrillic_be,
        //ffi::XK_Cyrillic_TSE => events::VirtualKeyCode::Cyrillic_tse,
        //ffi::XK_Cyrillic_DE => events::VirtualKeyCode::Cyrillic_de,
        //ffi::XK_Cyrillic_IE => events::VirtualKeyCode::Cyrillic_ie,
        //ffi::XK_Cyrillic_EF => events::VirtualKeyCode::Cyrillic_ef,
        //ffi::XK_Cyrillic_GHE => events::VirtualKeyCode::Cyrillic_ghe,
        //ffi::XK_Cyrillic_HA => events::VirtualKeyCode::Cyrillic_ha,
        //ffi::XK_Cyrillic_I => events::VirtualKeyCode::Cyrillic_i,
        //ffi::XK_Cyrillic_SHORTI => events::VirtualKeyCode::Cyrillic_shorti,
        //ffi::XK_Cyrillic_KA => events::VirtualKeyCode::Cyrillic_ka,
        //ffi::XK_Cyrillic_EL => events::VirtualKeyCode::Cyrillic_el,
        //ffi::XK_Cyrillic_EM => events::VirtualKeyCode::Cyrillic_em,
        //ffi::XK_Cyrillic_EN => events::VirtualKeyCode::Cyrillic_en,
        //ffi::XK_Cyrillic_O => events::VirtualKeyCode::Cyrillic_o,
        //ffi::XK_Cyrillic_PE => events::VirtualKeyCode::Cyrillic_pe,
        //ffi::XK_Cyrillic_YA => events::VirtualKeyCode::Cyrillic_ya,
        //ffi::XK_Cyrillic_ER => events::VirtualKeyCode::Cyrillic_er,
        //ffi::XK_Cyrillic_ES => events::VirtualKeyCode::Cyrillic_es,
        //ffi::XK_Cyrillic_TE => events::VirtualKeyCode::Cyrillic_te,
        //ffi::XK_Cyrillic_U => events::VirtualKeyCode::Cyrillic_u,
        //ffi::XK_Cyrillic_ZHE => events::VirtualKeyCode::Cyrillic_zhe,
        //ffi::XK_Cyrillic_VE => events::VirtualKeyCode::Cyrillic_ve,
        //ffi::XK_Cyrillic_SOFTSIGN => events::VirtualKeyCode::Cyrillic_softsign,
        //ffi::XK_Cyrillic_YERU => events::VirtualKeyCode::Cyrillic_yeru,
        //ffi::XK_Cyrillic_ZE => events::VirtualKeyCode::Cyrillic_ze,
        //ffi::XK_Cyrillic_SHA => events::VirtualKeyCode::Cyrillic_sha,
        //ffi::XK_Cyrillic_E => events::VirtualKeyCode::Cyrillic_e,
        //ffi::XK_Cyrillic_SHCHA => events::VirtualKeyCode::Cyrillic_shcha,
        //ffi::XK_Cyrillic_CHE => events::VirtualKeyCode::Cyrillic_che,
        //ffi::XK_Cyrillic_HARDSIGN => events::VirtualKeyCode::Cyrillic_hardsign,
        //ffi::XK_Greek_ALPHAaccent => events::VirtualKeyCode::Greek_alphaaccent,
        //ffi::XK_Greek_EPSILONaccent => events::VirtualKeyCode::Greek_epsilonaccent,
        //ffi::XK_Greek_ETAaccent => events::VirtualKeyCode::Greek_etaaccent,
        //ffi::XK_Greek_IOTAaccent => events::VirtualKeyCode::Greek_iotaaccent,
        //ffi::XK_Greek_IOTAdiaeresis => events::VirtualKeyCode::Greek_iotadiaeresis,
        //ffi::XK_Greek_OMICRONaccent => events::VirtualKeyCode::Greek_omicronaccent,
        //ffi::XK_Greek_UPSILONaccent => events::VirtualKeyCode::Greek_upsilonaccent,
        //ffi::XK_Greek_UPSILONdieresis => events::VirtualKeyCode::Greek_upsilondieresis,
        //ffi::XK_Greek_OMEGAaccent => events::VirtualKeyCode::Greek_omegaaccent,
        //ffi::XK_Greek_accentdieresis => events::VirtualKeyCode::Greek_accentdieresis,
        //ffi::XK_Greek_horizbar => events::VirtualKeyCode::Greek_horizbar,
        //ffi::XK_Greek_alphaaccent => events::VirtualKeyCode::Greek_alphaaccent,
        //ffi::XK_Greek_epsilonaccent => events::VirtualKeyCode::Greek_epsilonaccent,
        //ffi::XK_Greek_etaaccent => events::VirtualKeyCode::Greek_etaaccent,
        //ffi::XK_Greek_iotaaccent => events::VirtualKeyCode::Greek_iotaaccent,
        //ffi::XK_Greek_iotadieresis => events::VirtualKeyCode::Greek_iotadieresis,
        //ffi::XK_Greek_iotaaccentdieresis => events::VirtualKeyCode::Greek_iotaaccentdieresis,
        //ffi::XK_Greek_omicronaccent => events::VirtualKeyCode::Greek_omicronaccent,
        //ffi::XK_Greek_upsilonaccent => events::VirtualKeyCode::Greek_upsilonaccent,
        //ffi::XK_Greek_upsilondieresis => events::VirtualKeyCode::Greek_upsilondieresis,
        //ffi::XK_Greek_upsilonaccentdieresis => events::VirtualKeyCode::Greek_upsilonaccentdieresis,
        //ffi::XK_Greek_omegaaccent => events::VirtualKeyCode::Greek_omegaaccent,
        //ffi::XK_Greek_ALPHA => events::VirtualKeyCode::Greek_alpha,
        //ffi::XK_Greek_BETA => events::VirtualKeyCode::Greek_beta,
        //ffi::XK_Greek_GAMMA => events::VirtualKeyCode::Greek_gamma,
        //ffi::XK_Greek_DELTA => events::VirtualKeyCode::Greek_delta,
        //ffi::XK_Greek_EPSILON => events::VirtualKeyCode::Greek_epsilon,
        //ffi::XK_Greek_ZETA => events::VirtualKeyCode::Greek_zeta,
        //ffi::XK_Greek_ETA => events::VirtualKeyCode::Greek_eta,
        //ffi::XK_Greek_THETA => events::VirtualKeyCode::Greek_theta,
        //ffi::XK_Greek_IOTA => events::VirtualKeyCode::Greek_iota,
        //ffi::XK_Greek_KAPPA => events::VirtualKeyCode::Greek_kappa,
        //ffi::XK_Greek_LAMDA => events::VirtualKeyCode::Greek_lamda,
        //ffi::XK_Greek_LAMBDA => events::VirtualKeyCode::Greek_lambda,
        //ffi::XK_Greek_MU => events::VirtualKeyCode::Greek_mu,
        //ffi::XK_Greek_NU => events::VirtualKeyCode::Greek_nu,
        //ffi::XK_Greek_XI => events::VirtualKeyCode::Greek_xi,
        //ffi::XK_Greek_OMICRON => events::VirtualKeyCode::Greek_omicron,
        //ffi::XK_Greek_PI => events::VirtualKeyCode::Greek_pi,
        //ffi::XK_Greek_RHO => events::VirtualKeyCode::Greek_rho,
        //ffi::XK_Greek_SIGMA => events::VirtualKeyCode::Greek_sigma,
        //ffi::XK_Greek_TAU => events::VirtualKeyCode::Greek_tau,
        //ffi::XK_Greek_UPSILON => events::VirtualKeyCode::Greek_upsilon,
        //ffi::XK_Greek_PHI => events::VirtualKeyCode::Greek_phi,
        //ffi::XK_Greek_CHI => events::VirtualKeyCode::Greek_chi,
        //ffi::XK_Greek_PSI => events::VirtualKeyCode::Greek_psi,
        //ffi::XK_Greek_OMEGA => events::VirtualKeyCode::Greek_omega,
        //ffi::XK_Greek_alpha => events::VirtualKeyCode::Greek_alpha,
        //ffi::XK_Greek_beta => events::VirtualKeyCode::Greek_beta,
        //ffi::XK_Greek_gamma => events::VirtualKeyCode::Greek_gamma,
        //ffi::XK_Greek_delta => events::VirtualKeyCode::Greek_delta,
        //ffi::XK_Greek_epsilon => events::VirtualKeyCode::Greek_epsilon,
        //ffi::XK_Greek_zeta => events::VirtualKeyCode::Greek_zeta,
        //ffi::XK_Greek_eta => events::VirtualKeyCode::Greek_eta,
        //ffi::XK_Greek_theta => events::VirtualKeyCode::Greek_theta,
        //ffi::XK_Greek_iota => events::VirtualKeyCode::Greek_iota,
        //ffi::XK_Greek_kappa => events::VirtualKeyCode::Greek_kappa,
        //ffi::XK_Greek_lamda => events::VirtualKeyCode::Greek_lamda,
        //ffi::XK_Greek_lambda => events::VirtualKeyCode::Greek_lambda,
        //ffi::XK_Greek_mu => events::VirtualKeyCode::Greek_mu,
        //ffi::XK_Greek_nu => events::VirtualKeyCode::Greek_nu,
        //ffi::XK_Greek_xi => events::VirtualKeyCode::Greek_xi,
        //ffi::XK_Greek_omicron => events::VirtualKeyCode::Greek_omicron,
        //ffi::XK_Greek_pi => events::VirtualKeyCode::Greek_pi,
        //ffi::XK_Greek_rho => events::VirtualKeyCode::Greek_rho,
        //ffi::XK_Greek_sigma => events::VirtualKeyCode::Greek_sigma,
        //ffi::XK_Greek_finalsmallsigma => events::VirtualKeyCode::Greek_finalsmallsigma,
        //ffi::XK_Greek_tau => events::VirtualKeyCode::Greek_tau,
        //ffi::XK_Greek_upsilon => events::VirtualKeyCode::Greek_upsilon,
        //ffi::XK_Greek_phi => events::VirtualKeyCode::Greek_phi,
        //ffi::XK_Greek_chi => events::VirtualKeyCode::Greek_chi,
        //ffi::XK_Greek_psi => events::VirtualKeyCode::Greek_psi,
        //ffi::XK_Greek_omega => events::VirtualKeyCode::Greek_omega,
        //ffi::XK_Greek_switch => events::VirtualKeyCode::Greek_switch,
        //ffi::XK_leftradical => events::VirtualKeyCode::Leftradical,
        //ffi::XK_topleftradical => events::VirtualKeyCode::Topleftradical,
        //ffi::XK_horizconnector => events::VirtualKeyCode::Horizconnector,
        //ffi::XK_topintegral => events::VirtualKeyCode::Topintegral,
        //ffi::XK_botintegral => events::VirtualKeyCode::Botintegral,
        //ffi::XK_vertconnector => events::VirtualKeyCode::Vertconnector,
        //ffi::XK_topleftsqbracket => events::VirtualKeyCode::Topleftsqbracket,
        //ffi::XK_botleftsqbracket => events::VirtualKeyCode::Botleftsqbracket,
        //ffi::XK_toprightsqbracket => events::VirtualKeyCode::Toprightsqbracket,
        //ffi::XK_botrightsqbracket => events::VirtualKeyCode::Botrightsqbracket,
        //ffi::XK_topleftparens => events::VirtualKeyCode::Topleftparens,
        //ffi::XK_botleftparens => events::VirtualKeyCode::Botleftparens,
        //ffi::XK_toprightparens => events::VirtualKeyCode::Toprightparens,
        //ffi::XK_botrightparens => events::VirtualKeyCode::Botrightparens,
        //ffi::XK_leftmiddlecurlybrace => events::VirtualKeyCode::Leftmiddlecurlybrace,
        //ffi::XK_rightmiddlecurlybrace => events::VirtualKeyCode::Rightmiddlecurlybrace,
        //ffi::XK_topleftsummation => events::VirtualKeyCode::Topleftsummation,
        //ffi::XK_botleftsummation => events::VirtualKeyCode::Botleftsummation,
        //ffi::XK_topvertsummationconnector => events::VirtualKeyCode::Topvertsummationconnector,
        //ffi::XK_botvertsummationconnector => events::VirtualKeyCode::Botvertsummationconnector,
        //ffi::XK_toprightsummation => events::VirtualKeyCode::Toprightsummation,
        //ffi::XK_botrightsummation => events::VirtualKeyCode::Botrightsummation,
        //ffi::XK_rightmiddlesummation => events::VirtualKeyCode::Rightmiddlesummation,
        //ffi::XK_lessthanequal => events::VirtualKeyCode::Lessthanequal,
        //ffi::XK_notequal => events::VirtualKeyCode::Notequal,
        //ffi::XK_greaterthanequal => events::VirtualKeyCode::Greaterthanequal,
        //ffi::XK_integral => events::VirtualKeyCode::Integral,
        //ffi::XK_therefore => events::VirtualKeyCode::Therefore,
        //ffi::XK_variation => events::VirtualKeyCode::Variation,
        //ffi::XK_infinity => events::VirtualKeyCode::Infinity,
        //ffi::XK_nabla => events::VirtualKeyCode::Nabla,
        //ffi::XK_approximate => events::VirtualKeyCode::Approximate,
        //ffi::XK_similarequal => events::VirtualKeyCode::Similarequal,
        //ffi::XK_ifonlyif => events::VirtualKeyCode::Ifonlyif,
        //ffi::XK_implies => events::VirtualKeyCode::Implies,
        //ffi::XK_identical => events::VirtualKeyCode::Identical,
        //ffi::XK_radical => events::VirtualKeyCode::Radical,
        //ffi::XK_includedin => events::VirtualKeyCode::Includedin,
        //ffi::XK_includes => events::VirtualKeyCode::Includes,
        //ffi::XK_intersection => events::VirtualKeyCode::Intersection,
        //ffi::XK_union => events::VirtualKeyCode::Union,
        //ffi::XK_logicaland => events::VirtualKeyCode::Logicaland,
        //ffi::XK_logicalor => events::VirtualKeyCode::Logicalor,
        //ffi::XK_partialderivative => events::VirtualKeyCode::Partialderivative,
        //ffi::XK_function => events::VirtualKeyCode::Function,
        //ffi::XK_leftarrow => events::VirtualKeyCode::Leftarrow,
        //ffi::XK_uparrow => events::VirtualKeyCode::Uparrow,
        //ffi::XK_rightarrow => events::VirtualKeyCode::Rightarrow,
        //ffi::XK_downarrow => events::VirtualKeyCode::Downarrow,
        //ffi::XK_blank => events::VirtualKeyCode::Blank,
        //ffi::XK_soliddiamond => events::VirtualKeyCode::Soliddiamond,
        //ffi::XK_checkerboard => events::VirtualKeyCode::Checkerboard,
        //ffi::XK_ht => events::VirtualKeyCode::Ht,
        //ffi::XK_ff => events::VirtualKeyCode::Ff,
        //ffi::XK_cr => events::VirtualKeyCode::Cr,
        //ffi::XK_lf => events::VirtualKeyCode::Lf,
        //ffi::XK_nl => events::VirtualKeyCode::Nl,
        //ffi::XK_vt => events::VirtualKeyCode::Vt,
        //ffi::XK_lowrightcorner => events::VirtualKeyCode::Lowrightcorner,
        //ffi::XK_uprightcorner => events::VirtualKeyCode::Uprightcorner,
        //ffi::XK_upleftcorner => events::VirtualKeyCode::Upleftcorner,
        //ffi::XK_lowleftcorner => events::VirtualKeyCode::Lowleftcorner,
        //ffi::XK_crossinglines => events::VirtualKeyCode::Crossinglines,
        //ffi::XK_horizlinescan1 => events::VirtualKeyCode::Horizlinescan1,
        //ffi::XK_horizlinescan3 => events::VirtualKeyCode::Horizlinescan3,
        //ffi::XK_horizlinescan5 => events::VirtualKeyCode::Horizlinescan5,
        //ffi::XK_horizlinescan7 => events::VirtualKeyCode::Horizlinescan7,
        //ffi::XK_horizlinescan9 => events::VirtualKeyCode::Horizlinescan9,
        //ffi::XK_leftt => events::VirtualKeyCode::Leftt,
        //ffi::XK_rightt => events::VirtualKeyCode::Rightt,
        //ffi::XK_bott => events::VirtualKeyCode::Bott,
        //ffi::XK_topt => events::VirtualKeyCode::Topt,
        //ffi::XK_vertbar => events::VirtualKeyCode::Vertbar,
        //ffi::XK_emspace => events::VirtualKeyCode::Emspace,
        //ffi::XK_enspace => events::VirtualKeyCode::Enspace,
        //ffi::XK_em3space => events::VirtualKeyCode::Em3space,
        //ffi::XK_em4space => events::VirtualKeyCode::Em4space,
        //ffi::XK_digitspace => events::VirtualKeyCode::Digitspace,
        //ffi::XK_punctspace => events::VirtualKeyCode::Punctspace,
        //ffi::XK_thinspace => events::VirtualKeyCode::Thinspace,
        //ffi::XK_hairspace => events::VirtualKeyCode::Hairspace,
        //ffi::XK_emdash => events::VirtualKeyCode::Emdash,
        //ffi::XK_endash => events::VirtualKeyCode::Endash,
        //ffi::XK_signifblank => events::VirtualKeyCode::Signifblank,
        //ffi::XK_ellipsis => events::VirtualKeyCode::Ellipsis,
        //ffi::XK_doubbaselinedot => events::VirtualKeyCode::Doubbaselinedot,
        //ffi::XK_onethird => events::VirtualKeyCode::Onethird,
        //ffi::XK_twothirds => events::VirtualKeyCode::Twothirds,
        //ffi::XK_onefifth => events::VirtualKeyCode::Onefifth,
        //ffi::XK_twofifths => events::VirtualKeyCode::Twofifths,
        //ffi::XK_threefifths => events::VirtualKeyCode::Threefifths,
        //ffi::XK_fourfifths => events::VirtualKeyCode::Fourfifths,
        //ffi::XK_onesixth => events::VirtualKeyCode::Onesixth,
        //ffi::XK_fivesixths => events::VirtualKeyCode::Fivesixths,
        //ffi::XK_careof => events::VirtualKeyCode::Careof,
        //ffi::XK_figdash => events::VirtualKeyCode::Figdash,
        //ffi::XK_leftanglebracket => events::VirtualKeyCode::Leftanglebracket,
        //ffi::XK_decimalpoint => events::VirtualKeyCode::Decimalpoint,
        //ffi::XK_rightanglebracket => events::VirtualKeyCode::Rightanglebracket,
        //ffi::XK_marker => events::VirtualKeyCode::Marker,
        //ffi::XK_oneeighth => events::VirtualKeyCode::Oneeighth,
        //ffi::XK_threeeighths => events::VirtualKeyCode::Threeeighths,
        //ffi::XK_fiveeighths => events::VirtualKeyCode::Fiveeighths,
        //ffi::XK_seveneighths => events::VirtualKeyCode::Seveneighths,
        //ffi::XK_trademark => events::VirtualKeyCode::Trademark,
        //ffi::XK_signaturemark => events::VirtualKeyCode::Signaturemark,
        //ffi::XK_trademarkincircle => events::VirtualKeyCode::Trademarkincircle,
        //ffi::XK_leftopentriangle => events::VirtualKeyCode::Leftopentriangle,
        //ffi::XK_rightopentriangle => events::VirtualKeyCode::Rightopentriangle,
        //ffi::XK_emopencircle => events::VirtualKeyCode::Emopencircle,
        //ffi::XK_emopenrectangle => events::VirtualKeyCode::Emopenrectangle,
        //ffi::XK_leftsinglequotemark => events::VirtualKeyCode::Leftsinglequotemark,
        //ffi::XK_rightsinglequotemark => events::VirtualKeyCode::Rightsinglequotemark,
        //ffi::XK_leftdoublequotemark => events::VirtualKeyCode::Leftdoublequotemark,
        //ffi::XK_rightdoublequotemark => events::VirtualKeyCode::Rightdoublequotemark,
        //ffi::XK_prescription => events::VirtualKeyCode::Prescription,
        //ffi::XK_minutes => events::VirtualKeyCode::Minutes,
        //ffi::XK_seconds => events::VirtualKeyCode::Seconds,
        //ffi::XK_latincross => events::VirtualKeyCode::Latincross,
        //ffi::XK_hexagram => events::VirtualKeyCode::Hexagram,
        //ffi::XK_filledrectbullet => events::VirtualKeyCode::Filledrectbullet,
        //ffi::XK_filledlefttribullet => events::VirtualKeyCode::Filledlefttribullet,
        //ffi::XK_filledrighttribullet => events::VirtualKeyCode::Filledrighttribullet,
        //ffi::XK_emfilledcircle => events::VirtualKeyCode::Emfilledcircle,
        //ffi::XK_emfilledrect => events::VirtualKeyCode::Emfilledrect,
        //ffi::XK_enopencircbullet => events::VirtualKeyCode::Enopencircbullet,
        //ffi::XK_enopensquarebullet => events::VirtualKeyCode::Enopensquarebullet,
        //ffi::XK_openrectbullet => events::VirtualKeyCode::Openrectbullet,
        //ffi::XK_opentribulletup => events::VirtualKeyCode::Opentribulletup,
        //ffi::XK_opentribulletdown => events::VirtualKeyCode::Opentribulletdown,
        //ffi::XK_openstar => events::VirtualKeyCode::Openstar,
        //ffi::XK_enfilledcircbullet => events::VirtualKeyCode::Enfilledcircbullet,
        //ffi::XK_enfilledsqbullet => events::VirtualKeyCode::Enfilledsqbullet,
        //ffi::XK_filledtribulletup => events::VirtualKeyCode::Filledtribulletup,
        //ffi::XK_filledtribulletdown => events::VirtualKeyCode::Filledtribulletdown,
        //ffi::XK_leftpointer => events::VirtualKeyCode::Leftpointer,
        //ffi::XK_rightpointer => events::VirtualKeyCode::Rightpointer,
        //ffi::XK_club => events::VirtualKeyCode::Club,
        //ffi::XK_diamond => events::VirtualKeyCode::Diamond,
        //ffi::XK_heart => events::VirtualKeyCode::Heart,
        //ffi::XK_maltesecross => events::VirtualKeyCode::Maltesecross,
        //ffi::XK_dagger => events::VirtualKeyCode::Dagger,
        //ffi::XK_doubledagger => events::VirtualKeyCode::Doubledagger,
        //ffi::XK_checkmark => events::VirtualKeyCode::Checkmark,
        //ffi::XK_ballotcross => events::VirtualKeyCode::Ballotcross,
        //ffi::XK_musicalsharp => events::VirtualKeyCode::Musicalsharp,
        //ffi::XK_musicalflat => events::VirtualKeyCode::Musicalflat,
        //ffi::XK_malesymbol => events::VirtualKeyCode::Malesymbol,
        //ffi::XK_femalesymbol => events::VirtualKeyCode::Femalesymbol,
        //ffi::XK_telephone => events::VirtualKeyCode::Telephone,
        //ffi::XK_telephonerecorder => events::VirtualKeyCode::Telephonerecorder,
        //ffi::XK_phonographcopyright => events::VirtualKeyCode::Phonographcopyright,
        //ffi::XK_caret => events::VirtualKeyCode::Caret,
        //ffi::XK_singlelowquotemark => events::VirtualKeyCode::Singlelowquotemark,
        //ffi::XK_doublelowquotemark => events::VirtualKeyCode::Doublelowquotemark,
        //ffi::XK_cursor => events::VirtualKeyCode::Cursor,
        //ffi::XK_leftcaret => events::VirtualKeyCode::Leftcaret,
        //ffi::XK_rightcaret => events::VirtualKeyCode::Rightcaret,
        //ffi::XK_downcaret => events::VirtualKeyCode::Downcaret,
        //ffi::XK_upcaret => events::VirtualKeyCode::Upcaret,
        //ffi::XK_overbar => events::VirtualKeyCode::Overbar,
        //ffi::XK_downtack => events::VirtualKeyCode::Downtack,
        //ffi::XK_upshoe => events::VirtualKeyCode::Upshoe,
        //ffi::XK_downstile => events::VirtualKeyCode::Downstile,
        //ffi::XK_underbar => events::VirtualKeyCode::Underbar,
        //ffi::XK_jot => events::VirtualKeyCode::Jot,
        //ffi::XK_quad => events::VirtualKeyCode::Quad,
        //ffi::XK_uptack => events::VirtualKeyCode::Uptack,
        //ffi::XK_circle => events::VirtualKeyCode::Circle,
        //ffi::XK_upstile => events::VirtualKeyCode::Upstile,
        //ffi::XK_downshoe => events::VirtualKeyCode::Downshoe,
        //ffi::XK_rightshoe => events::VirtualKeyCode::Rightshoe,
        //ffi::XK_leftshoe => events::VirtualKeyCode::Leftshoe,
        //ffi::XK_lefttack => events::VirtualKeyCode::Lefttack,
        //ffi::XK_righttack => events::VirtualKeyCode::Righttack,
        //ffi::XK_hebrew_doublelowline => events::VirtualKeyCode::Hebrew_doublelowline,
        //ffi::XK_hebrew_aleph => events::VirtualKeyCode::Hebrew_aleph,
        //ffi::XK_hebrew_bet => events::VirtualKeyCode::Hebrew_bet,
        //ffi::XK_hebrew_beth => events::VirtualKeyCode::Hebrew_beth,
        //ffi::XK_hebrew_gimel => events::VirtualKeyCode::Hebrew_gimel,
        //ffi::XK_hebrew_gimmel => events::VirtualKeyCode::Hebrew_gimmel,
        //ffi::XK_hebrew_dalet => events::VirtualKeyCode::Hebrew_dalet,
        //ffi::XK_hebrew_daleth => events::VirtualKeyCode::Hebrew_daleth,
        //ffi::XK_hebrew_he => events::VirtualKeyCode::Hebrew_he,
        //ffi::XK_hebrew_waw => events::VirtualKeyCode::Hebrew_waw,
        //ffi::XK_hebrew_zain => events::VirtualKeyCode::Hebrew_zain,
        //ffi::XK_hebrew_zayin => events::VirtualKeyCode::Hebrew_zayin,
        //ffi::XK_hebrew_chet => events::VirtualKeyCode::Hebrew_chet,
        //ffi::XK_hebrew_het => events::VirtualKeyCode::Hebrew_het,
        //ffi::XK_hebrew_tet => events::VirtualKeyCode::Hebrew_tet,
        //ffi::XK_hebrew_teth => events::VirtualKeyCode::Hebrew_teth,
        //ffi::XK_hebrew_yod => events::VirtualKeyCode::Hebrew_yod,
        //ffi::XK_hebrew_finalkaph => events::VirtualKeyCode::Hebrew_finalkaph,
        //ffi::XK_hebrew_kaph => events::VirtualKeyCode::Hebrew_kaph,
        //ffi::XK_hebrew_lamed => events::VirtualKeyCode::Hebrew_lamed,
        //ffi::XK_hebrew_finalmem => events::VirtualKeyCode::Hebrew_finalmem,
        //ffi::XK_hebrew_mem => events::VirtualKeyCode::Hebrew_mem,
        //ffi::XK_hebrew_finalnun => events::VirtualKeyCode::Hebrew_finalnun,
        //ffi::XK_hebrew_nun => events::VirtualKeyCode::Hebrew_nun,
        //ffi::XK_hebrew_samech => events::VirtualKeyCode::Hebrew_samech,
        //ffi::XK_hebrew_samekh => events::VirtualKeyCode::Hebrew_samekh,
        //ffi::XK_hebrew_ayin => events::VirtualKeyCode::Hebrew_ayin,
        //ffi::XK_hebrew_finalpe => events::VirtualKeyCode::Hebrew_finalpe,
        //ffi::XK_hebrew_pe => events::VirtualKeyCode::Hebrew_pe,
        //ffi::XK_hebrew_finalzade => events::VirtualKeyCode::Hebrew_finalzade,
        //ffi::XK_hebrew_finalzadi => events::VirtualKeyCode::Hebrew_finalzadi,
        //ffi::XK_hebrew_zade => events::VirtualKeyCode::Hebrew_zade,
        //ffi::XK_hebrew_zadi => events::VirtualKeyCode::Hebrew_zadi,
        //ffi::XK_hebrew_qoph => events::VirtualKeyCode::Hebrew_qoph,
        //ffi::XK_hebrew_kuf => events::VirtualKeyCode::Hebrew_kuf,
        //ffi::XK_hebrew_resh => events::VirtualKeyCode::Hebrew_resh,
        //ffi::XK_hebrew_shin => events::VirtualKeyCode::Hebrew_shin,
        //ffi::XK_hebrew_taw => events::VirtualKeyCode::Hebrew_taw,
        //ffi::XK_hebrew_taf => events::VirtualKeyCode::Hebrew_taf,
        //ffi::XK_Hebrew_switch => events::VirtualKeyCode::Hebrew_switch,
        ffi::XF86XK_Back => VirtualKeyCode::NavigateBackward,
        ffi::XF86XK_Forward => VirtualKeyCode::NavigateForward,
        ffi::XF86XK_Copy => VirtualKeyCode::Copy,
        ffi::XF86XK_Paste => VirtualKeyCode::Paste,
        ffi::XF86XK_Cut => VirtualKeyCode::Cut,
        _ => return None
    })
}
